org.mozilla.javascript.ast

## Class AstRoot

- java.lang.Object
- - org.mozilla.javascript.Node
  - - org.mozilla.javascript.ast.AstNode
    - - org.mozilla.javascript.ast.Jump
      - - org.mozilla.javascript.ast.Scope
        - - org.mozilla.javascript.ast.ScriptNode
          - - org.mozilla.javascript.ast.AstRoot

All Implemented Interfaces:
  java.lang.Comparable<AstNode>, java.lang.Iterable<Node>

    public class AstRoot
    extends ScriptNode

Node for the root of a parse tree. It contains the statements and functions in the script, and a list of `Comment` nodes associated with the script as a whole. Node type is `Token.SCRIPT`.

Note that the tree itself does not store errors. To collect the parse errors and warnings, pass an `ErrorReporter` to the `Parser` via the `CompilerEnvirons`.

### Nested Class Summary

### Nested classes/interfaces inherited from class org.mozilla.javascript.ast.AstNode

`AstNode.DebugPrintVisitor, AstNode.PositionComparator`

### Nested classes/interfaces inherited from class org.mozilla.javascript.Node

`Node.NodeIterator`

### Field Summary

### Fields inherited from class org.mozilla.javascript.ast.Scope

`parentScope, symbolTable, top`

### Fields inherited from class org.mozilla.javascript.ast.Jump

`target`

### Fields inherited from class org.mozilla.javascript.ast.AstNode

`length, parent, position`

### Fields inherited from class org.mozilla.javascript.Node

`ATTRIBUTE_FLAG, BOTH, CASEARRAY_PROP, CATCH_SCOPE_PROP, CONTROL_BLOCK_PROP, DECR_FLAG, DESCENDANTS_FLAG, DESTRUCTURING_ARRAY_LENGTH, DESTRUCTURING_NAMES, DESTRUCTURING_PARAMS, DESTRUCTURING_SHORTHAND, DIRECTCALL_PROP, END_DROPS_OFF, END_RETURNS, END_RETURNS_VALUE, END_UNREACHED, END_YIELDS, EXPRESSION_CLOSURE_PROP, first, FUNCTION_PROP, GENERATOR_END_PROP, INCRDECR_PROP, ISNUMBER_PROP, JSDOC_PROP, LABEL_ID_PROP, last, LAST_PROP, LEFT, lineno, LOCAL_BLOCK_PROP, LOCAL_PROP, MEMBER_TYPE_PROP, NAME_PROP, next, NON_SPECIALCALL, OBJECT_IDS_PROP, PARENTHESIZED_PROP, POST_FLAG, PROPERTY_FLAG, propListHead, REGEXP_PROP, RIGHT, SKIP_INDEXES_PROP, SPECIALCALL_EVAL, SPECIALCALL_PROP, SPECIALCALL_WITH, TARGETBLOCK_PROP, type, VARIABLE_PROP`

### Constructor Summary

Constructors
Constructor and Description
`AstRoot()`
`AstRoot(int pos)`

### Method Summary

Methods
`void` `addComment(Comment comment)` Add a comment to the comment set.
`void` `checkParentLinks()` Debugging function to check that the parser has set the parent link for every node in the tree.
`java.lang.String` `debugPrint()` A debug-printer that includes comments (at the end).
`java.util.SortedSet<Comment>` `getComments()` Returns comment set
`boolean` `isInStrictMode()`
`void` `setComments(java.util.SortedSet<Comment> comments)` Sets comment list, and updates the parent of each entry to point to this node.
`void` `setInStrictMode(boolean inStrictMode)`
`java.lang.String` `toSource(int depth)` Emits source code for this node.
`void` `visitAll(NodeVisitor visitor)` Visits the AST nodes, then the comment nodes.
`void` `visitComments(NodeVisitor visitor)` Visits the comment nodes in the order they appear in the source code.

### Methods inherited from class org.mozilla.javascript.ast.ScriptNode

`addFunction, addRegExp, flattenSymbolTable, getBaseLineno, getCompilerData, getEncodedSource, getEncodedSourceEnd, getEncodedSourceStart, getEndLineno, getFunctionCount, getFunctionNode, getFunctions, getIndexForNameNode, getNextTempName, getParamAndVarConst, getParamAndVarCount, getParamAndVarNames, getParamCount, getParamOrVarName, getRegexpCount, getRegexpFlags, getRegexpString, getSourceName, getSymbols, setBaseLineno, setCompilerData, setEncodedSource, setEncodedSourceBounds, setEncodedSourceEnd, setEncodedSourceStart, setEndLineno, setSourceName, setSymbols, visit`

### Methods inherited from class org.mozilla.javascript.ast.Scope

`addChildScope, clearParentScope, getChildScopes, getDefiningScope, getParentScope, getStatements, getSymbol, getSymbolTable, getTop, joinScopes, putSymbol, replaceWith, setParentScope, setSymbolTable, setTop, splitScope`

### Methods inherited from class org.mozilla.javascript.ast.Jump

`getContinue, getDefault, getFinally, getJumpStatement, getLoop, setContinue, setDefault, setFinally, setJumpStatement, setLoop`

### Methods inherited from class org.mozilla.javascript.ast.AstNode

`addChild, assertNotNull, codeBug, compareTo, depth, getAbsolutePosition, getAstRoot, getEnclosingFunction, getEnclosingScope, getLength, getLineno, getParent, getPosition, hasSideEffects, makeIndent, operatorToString, printList, setBounds, setLength, setParent, setPosition, setRelative, shortName, toSource`

### Methods inherited from class org.mozilla.javascript.Node

`addChildAfter, addChildBefore, addChildrenToBack, addChildrenToFront, addChildToBack, addChildToFront, getChildBefore, getDouble, getExistingIntProp, getFirstChild, getIntProp, getJsDoc, getJsDocNode, getLastChild, getLastSibling, getNext, getProp, getScope, getString, getType, hasChildren, hasConsistentReturnUsage, iterator, labelId, labelId, newNumber, newString, newString, newTarget, putIntProp, putProp, removeChild, removeChildren, removeProp, replaceChild, replaceChildAfter, resetTargets, setDouble, setJsDocNode, setLineno, setScope, setString, setType, toString, toStringTree`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### AstRoot

    public AstRoot()

#### AstRoot

    public AstRoot(int pos)

### Method Detail

#### getComments

    public java.util.SortedSet<Comment> getComments()

Returns comment set

Returns:
  comment set, sorted by start position. Can be `null`.

#### setComments

    public void setComments(java.util.SortedSet<Comment> comments)

Sets comment list, and updates the parent of each entry to point to this node. Replaces any existing comments.

Parameters:
  `comments` - comment list. can be `null`.

#### addComment

    public void addComment(Comment comment)

Add a comment to the comment set.

Parameters:
  `comment` - the comment node.
Throws:
  `java.lang.IllegalArgumentException` - if comment is `null`

#### setInStrictMode

    public void setInStrictMode(boolean inStrictMode)

#### isInStrictMode

    public boolean isInStrictMode()

#### visitComments

    public void visitComments(NodeVisitor visitor)

Visits the comment nodes in the order they appear in the source code. The comments are not visited by the `ScriptNode.visit(org.mozilla.javascript.ast.NodeVisitor)` function - you must use this function to visit them.

Parameters:
  `visitor` - the callback object. It is passed each comment node. The return value is ignored.

#### visitAll

    public void visitAll(NodeVisitor visitor)

Visits the AST nodes, then the comment nodes. This method is equivalent to calling `ScriptNode.visit(org.mozilla.javascript.ast.NodeVisitor)`, then `visitComments(org.mozilla.javascript.ast.NodeVisitor)`. The return value is ignored while visiting comment nodes.

Parameters:
  `visitor` - the callback object.

#### toSource

    public java.lang.String toSource(int depth)

Description copied from class: `AstNode`
Emits source code for this node. Callee is responsible for calling this function recursively on children, incrementing indent as appropriate.

Note: if the parser was in error-recovery mode, some AST nodes may have `null` children that are expected to be non-`null` when no errors are present. In this situation, the behavior of the `toSource` method is undefined: `toSource` implementations may assume that the AST node is error-free, since it is intended to be invoked only at runtime after a successful parse.

Overrides:
  `toSource` in class `Scope`
Parameters:
  `depth` - the current recursion depth, typically beginning at 0 when called on the root node.

#### debugPrint

    public java.lang.String debugPrint()

A debug-printer that includes comments (at the end).

Overrides:
  `debugPrint` in class `AstNode`
Returns:
  a very verbose indented printout of the tree. The format of each line is: abs-pos name position length [identifier]

#### checkParentLinks

    public void checkParentLinks()

Debugging function to check that the parser has set the parent link for every node in the tree.

Throws:
  `java.lang.IllegalStateException` - if a parent link is missing